<template>
  <div class="page">
    <b-container fluid>
      <b-row class="data-page">
        <b-col class="col-6 data-col">
          <ButtonItem
            :count="datasetsCount"
            :title="{
              singular: 'jeu de données',
              plural: 'jeux de données',
              article: {
                singular: 'un',
                plural: 'les'
              }
            }"
            :icon="'data_layers'"
            :routeTo="['Datasets', 'AddDataset']"
            :loading="!isDatasetsListLoaded"
          />
        </b-col>
        <b-col class="col-6 dashboard-col">
          <h4>Dernières tâches</h4>
          <div class="tasks-count">
          <b-overlay
            :show="reloadingTasks"
            :variant="'white'"
            rounded="lg"
            opacity="0.9"
          >
            <template #overlay>
              <div class="d-flex align-items-center">
                <b-spinner small variant="secondary"></b-spinner>
              </div>
            </template>
            <div style="line-height: 1.1em; vertical-align: middle;">
              {{
                dashboardTasksQueue.length > 0 && dashboardTasksQueue.filter(el => el.state !== 'SUCCESS' && el.state !== 'FAILURE').length > 0 ?
                  dashboardTasksQueue.filter(el => el.state !== 'SUCCESS' && el.state !== 'FAILURE').length :
                  'Aucune'
              }} 
              {{
                dashboardTasksQueue.length > 0 && dashboardTasksQueue.filter(el => el.state !== 'SUCCESS' && el.state !== 'FAILURE').length > 1 ?
                  'tâches' :
                  'tâche'
              }} en cours
            </div>
          </b-overlay>
          </div>
          <b-overlay
            id="overlay-background"
            :show="!isTasksQueueLoaded"
            :variant="'white'"
            :opacity="0.6"
            rounded="sm"
            blur="2px"
            style="width: 100%; min-height: 6rem;"
          >
            <TaskItem
              v-for="task of dashboardTasksQueue.slice(0, 5)"
              :key="task.id"
              :task="task"
            />
            <div v-if="dashboardTasksQueue.length === 0 && isTasksQueueLoaded" class="no-tasks">
              Aucune tâche n'a été lancée.
            </div>
          </b-overlay>
          <b-button
            v-if="isTasksQueueLoaded && dashboardTasksQueue.length > 0"
            class="btn-lg"
            style="margin-top: 1rem;"
            @click="$router.push({ name: 'Tasks' })"
          >
            Voir toutes les tâches
          </b-button>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>

<script>
import ButtonItem from '@/components/ButtonItem.vue';
import TaskItem from '@/components/TaskItem.vue';

import { mapState, mapMutations, mapActions } from 'vuex';

export default {
  name: 'Data',

  components : {
    ButtonItem,
    TaskItem
  },

  data() {
    return {
      isDatasetsListLoaded: false,
      isTasksQueueLoaded: false,
      reloadingTasks: false,
    };
  },

  computed: {
    ...mapState('datasets', [
      'datasetsCount',
      'datasetsList',
      'datasetsCategories',
      'datasetsGranularities',
      'datasetsLicences',
      'datasetsTopics',
      'datasetsKinds'
    ]),
    ...mapState('dashboard', [
      'dashboardTasksCount',
      'dashboardTasksQueue'
    ])
  },

  created() {
    this.getData();
    this.getConfigData();
  },

  mounted() {
    this.SET_RELOAD_INTERVAL_ID(setInterval(() => {
      this.reloadingTasks = true;
      this.GET_DASHBOARD_TASKS({
        direction: null,
        field: null
      })
      .then(() => {
        this.reloadingTasks = false;
      })
      .catch(() => {
        this.reloadingTasks = false;
      });
    }, process.env.VUE_APP_RELOAD_INTERVAL));
  },

  methods: {
    ...mapMutations(['SET_RELOAD_INTERVAL_ID']),
    ...mapActions('datasets', [
      'GET_DATASETS_COUNT',
      'GET_DATASETS_CATEGORIES',
      'GET_DATASETS_GRANULARITIES',
      'GET_DATASETS_LICENCES',
      'GET_DATASETS_TOPICS',
      'GET_DATASETS_KINDS'
    ]),
    ...mapActions('dashboard', [
      'GET_DASHBOARD_TASKS'
    ]),

    getData() {
      this.GET_DATASETS_COUNT()
        .then(() => {
          this.isDatasetsListLoaded = true;
        }).catch(() => {
          this.isDatasetsListLoaded = true;
        });
      this.isTasksQueueLoaded = false;
      this.GET_DASHBOARD_TASKS({
        direction: null,
        field: null
      })
        .then(() => {
          this.isTasksQueueLoaded = true;
        })
        .catch(() => {
          this.isTasksQueueLoaded = true;
        });
    },
    getConfigData() {
      if (this.datasetsCategories.length === 0) {
        this.GET_DATASETS_CATEGORIES();
      }
      if (this.datasetsGranularities.length === 0) {
        this.GET_DATASETS_GRANULARITIES();
      }
      if (this.datasetsLicences.length === 0) {
        this.GET_DATASETS_LICENCES();
      }
      if (this.datasetsTopics.length === 0) {
        this.GET_DATASETS_TOPICS();
      }
      if (this.datasetsKinds.length === 0) {
        this.GET_DATASETS_KINDS();
      }
    }
  }
}
</script>

<style lang="less">

.container-fluid {
  height: calc(100% - @footerHeight);
}
.dashboard-col {
  margin-top: 0.5rem;
}
.tasks-count {
  position: absolute;
  top: 0.5rem;
  right: 1rem;
}
.no-tasks {
  text-align: center;
  margin-top: 1rem;
  padding-top: 1rem;
  font-style: italic;
  color: rgb(82, 82, 82);
  font-size: 0.9em;
}

</style>
